#!/bin/sh
# Control standby mode on/off and count down.

vid=$1
pid=$2
OnOff=$3
vid_pid=$1_$2
ResetFile='/tmp/pscanner-reset_'$vid_pid
SettingFile='/usr/local/etc/sane.d/ini/'$vid_pid'_pwr.ini'
ScannerTimer=295
ScannerDefaultTimer=295
UserSettingTime=15
Counter=`expr 60 \* $UserSettingTime - $ScannerTimer`
#Counter=10
#echo ======================
#echo vid_pid=$vid_pid
#echo ResetFile=$ResetFile
#echo SettingFile=$SettingFile
#echo UserSettingTime=$UserSettingTime
#echo ScannerTimer=$ScannerTimer
#echo Counter=$Counter
#echo ======================

#Get user setting if there is no setting create setting file and set default value as 15
if [ -e $SettingFile ] 
then
	UserSettingTime=`cat $SettingFile`
	echo Get UserSettingTime from $SettingFile. Value $UserSettingTime.
else 
	UserSettingTime=15
	echo $SettingFile does NOT exist. Create and set UserSettingTime equal 15.
	echo 15 > $SettingFile 
fi

chmod 666 $SettingFile

#Check reset file is exist or not. If it is not exist, create it.
if [ -e $ResetFile ] 
then
	echo ResetFile $ResetFile exist.
else
	echo ResetFile $ResetFile does not exist. Create it.
	echo 0 > $ResetFile
fi

#Countdown Loop
while :
do

sleep 1

#Get reset flag
if [ -e $ResetFile ] 
then
	reset=`cat $ResetFile`
else
	echo ResetFile=$ResetFile does not exist create it and set default value 0.
	echo 0 > $ResetFile
	reset=0
	#echo reset=$reset
fi

#Reset value check
#1: Scanner add - Read power save timer from ini and reset counter.
#2: Scanner remove - Reset counter
#3: Scanner scan - Reset counter
if [ $reset -eq 1 ] 
then
	echo Reset1 Scanner add. Read Counter from file and reset scanner timer to default and reset Counter.
	UserSettingTime=`cat $SettingFile`
	#echo UserSettingTime=$UserSettingTime min
	ScannerTimer=$ScannerDefaultTimer
	#echo ScannerTimer=$ScannerTimer secs
	Counter=`expr 60 \* $UserSettingTime - $ScannerTimer`
	#echo Counter=$Counter
	`echo 0 > $ResetFile`
elif [ $reset -eq 2 ] 
then
	echo Reset2 Scanner remove. Reset scanner timer to default. 
	ScannerTimer=$ScannerDefaultTimer
	`echo 0 > $ResetFile`
elif [ $reset -eq 3 ] 
then
	echo Reset3 Scanner scan. Reset Counter
	UserSettingTime=`cat $SettingFile`
	Counter=`expr 60 \* $UserSettingTime - $ScannerTimer`
	echo Counter=$Counter
	`echo 0 > $ResetFile`
fi


if [ $Counter -gt 0 ] 
then 
	Counter=`expr $Counter - 1`
fi

#Turn on standby mode
if [ $Counter -eq 1 ]
then 
	#Check device is blocked by application
	StartLine=`usb-devices | awk '/Vendor='"$vid"' ProdID='"$pid"'/{print NR}'`
	LineNum=5
	EndLine=`expr $StartLine + $LineNum`
	NoneDriver=`usb-devices | sed -n "$StartLine"','"$EndLine"'p' | grep none | wc -l`
	#echo Startline=$StartLine
	#echo EndLine=$EndLine
	#echo NoneDriver=$NoneDriver

	if [ $NoneDriver -eq 0 ]
	then
		#Get block program
		program=`lsof +D /usr/lib/ | grep libsane-pl | cut -d' ' -f1`
		echo $program
		echo libsaneplxxx open num=$libsanepl send signal to process.
		kill -12 `pidof $program`
	else
		#Get device name
		USBDevice=`sane-find-scanner | grep $pid | awk -F 'at ' '{print $2}'`
		USBDevice=`scanimage -L | grep "$USBDevice"`
		USBDevice=$(echo $USBDevice| cut -d '`' -f 2)
		USBDevice=$(echo $USBDevice| cut -d "'" -f 1)
		echo No application block device. Run scanimage --standby=yes -n
		scanimage --device-name=$USBDevice --standby=yes -n
	fi
elif [ $Counter -eq 0 ]
then 
	if [ $ScannerTimer -gt 0 ]
	then
	ScannerTimer=`expr $ScannerTimer - 1`
	fi
fi

#echo $vid:$pid Counter $Counter, ScannerTime $ScannerTimer
done
