#!/bin/bash
##########################################################
# Check scanner connect status via /tmp/pscanner-list
# If scanner connected(1) call pscanner-pwrctl.sh with argument vid pid 1
# If scanner connected(0) kill pscanner-pwrctl
##########################################################

vendorIDArray=("07b3" "33e1" "32ec" "20ec" "31c9" "2903" "3308")

for str in ${vendorIDArray[@]}; do
  ScannerNum=`lsusb | grep $str | wc -l`
  if [ $ScannerNum -gt 0 ]
  then
    echo find idVendor=$str scanner. Call udevadm trigger --action=add
    udevadm trigger --action=add --subsystem-match=usb --type=devices --attr-match=idVendor=$str
  fi
done

ScannerList='/tmp/pscanner-list'
touch $ScannerList

while :
do

#Get scanner status from /tmp/pscanner-list
#1: Add Scanner, 0: Remove Scanner, -1: processed
for str in `cat $ScannerList`
do
connect=${str#*,}
vid_pid=${str%,*}
vid=${vid_pid%_*}
pid=${vid_pid#*_}
echo $vid_pid connect=$connect

if [ $connect -eq 1 ] #Add Scanner
then
echo Scanner $vid $pid connected. Turn on power control.
#echo killprocess pscanner-pwrctl.sh pid `pgrep -f 'pscanner-pwrctl.sh '"$vid"' '"$pid"`
#echo Run /opt/apps/scanner-common-btit-driver/bin/pscanner-pwrctl.sh $vid $pid $connect &
/opt/apps/scanner-common-btit-driver/bin/pscanner-pwrctl.sh $vid $pid $connect &
sed -i '/'$vid'_'$pid'/d' $ScannerList
echo $vid'_'$pid',-1' >> $ScannerList
elif  [ $connect -eq 0 ] #Remove Scanner
then
sed -i '/'$vid'_'$pid'/d' $ScannerList
echo $vid'_'$pid',-1' >> $ScannerList
echo Scanner $vid $pid disconnected. Turn off power control.
kill -9 `pgrep -f 'pscanner-pwrctl.sh '"$vid"' '"$pid"`
fi
done

sleep 1
done
